<?php
/**
 *    @version 2.1.1 Build 21106 Alpha [ Drury ]
 *    @package hwdVideoShare
 *    @copyright (C) 2007 - 2009 Highwood Design
 *    @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 ***
 *    This program is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );
    /**
     * Prepares the code to insert the third party video
     *
     * @param string $row  the $video_id output containing video paramters
     * @param int    $flv_width  the video width
     * @param int    $flv_height  the video height
     * @return       $code   the third party embed code
     */
    function youtubeComPrepareVideo($row, $flv_width=null, $flv_height=null)
	{
		global $show_video_ad, $smarty, $task;
		if (!defined('HWDVIDSPATH')) { define('HWDVIDSPATH', dirname(__FILE__).'/../../'); }
		$c = hwd_vs_Config::get_instance();

			$code=null;

			if (@explode(",", $row->video_id)) {
				$data = explode(",", $row->video_id);
				$videocode = $data[0];
			} else {
			    return $code;
			}

			$truepath = youtubeComPrepareFlvURL($row->video_id);

			if (!empty($truepath) && $c->playlocal == "1") {

				$player = new hwd_vs_videoplayer();

				if ($show_video_ad == 1) {
					$xspf_playlist = JPATH_SITE."/components/com_hwdvideoshare/xml/xspf/".$row->id.".xml";
					@unlink($xspf_playlist);
                    require_once(HWDVIDSPATH.'/../../administrator/components/com_hwdrevenuemanager/redrawplaylist.class.php');
                    hwd_rm_playlist::writeFile($row);

					if (file_exists($xspf_playlist)) {
						$flv_url = JURI::root(true)."/components/com_hwdvideoshare/xml/xspf/".$row->id.".xml";
						$flv_path = HWDVIDSPATH.'/xml/xspf/'.$row->id.'.xml';

						require_once(HWDVIDSPATH.'/../../hwdvideos/plugin/videoplayer/'.$c->hwdvids_videoplayer_path.'/view.'.$c->hwdvids_videoplayer_file.'.php');
						$player = new hwd_vs_videoplayer();

						if ($c->loadswfobject == "on" && $task !=="grabjomsocialplayer") {
							$code.= $player->prepareplayer($flv_url, $flv_width, $flv_height, rand(100, 999), "playlist", $flv_path );
						} else {
							$code.= $player->prepareEmbeddedPlayer($flv_url, $flv_width, $flv_height, "playlist");
						}
						return $code;
					}
				}

				if ($c->loadswfobject == "on") {
					$code.= $player->prepareplayer($truepath, $flv_width, $flv_height, rand(100, 999), "video", null, $data[1]);
				} else {
					$code.= $player->prepareEmbeddedPlayer($truepath, $flv_width, $flv_height, "remote", $data[1]);
				}

				return $code;

			} else {

				if ($flv_width==null) {
					$smarty->assign("player_width", $c->tpwidth);
					$flv_width = $c->tpwidth."px";
				} else {
					$smarty->assign("player_width", $flv_width);
					if (preg_match("/%/", $flv_width)) {
						$flv_width = $flv_width;
					} else {
						$flv_width = $flv_width."px";
					}
				}
				if ($flv_height==null) {
					$flv_height = intval (($c->tpwidth * 0.75) + 27);
					$flv_height = $flv_height."px";
				} else {
					if (preg_match("/%/", $flv_height)) {
						$flv_height = $flv_height;
					} else {
						$flv_height = $flv_height."px";
					}
				}

				//$code = "<object width=\"".$flv_width."\" height=\"".$flv_height."\"><param name=\"movie\" value=\"http://www.youtube.com/v/".$videocode."&rel=0&fs=1&color1=0x3a3a3a&color2=0x999999&border=0\"></param><param name=\"allowFullScreen\" value=\"true\"></param><param name=\"wmode\" value=\"transparent\"></param><embed src=\"http://www.youtube.com/v/".$videocode."&rel=0&fs=1&color1=0x3a3a3a&color2=0x999999&border=0\" type=\"application/x-shockwave-flash\" wmode=\"transparent\" width=\"".$flv_width."\" height=\"".$flv_height."\" allowfullscreen=\"true\"></embed></object>";
				$code = "<embed src=\"http://www.youtube.com/v/".$videocode."&rel=0&fs=1&color1=0x3a3a3a&color2=0x999999&border=0&ap=%2526fmt%3D18\" type=\"application/x-shockwave-flash\" wmode=\"transparent\" width=\"".$flv_width."\" height=\"".$flv_height."\" allowfullscreen=\"true\"></embed>";
				return $code;
			}
	}
    /**
     * Prepares the code to insert the third party thumbnail image
     *
     * @param string $option  the $video_id output containing video paramters
     * @param int    $vid  the video database id
     * @param int    $Itemid  the joomla menu id
     * @param int    $k  the alternating CSS integer
     * @return       $code   the full third party thumbnail image tag
     */
	function youtubeComPrepareThumb($option, $vid, $Itemid, $k, $width=null, $height=null, $class=null)
	{
		global $mosConfig_live_site;
		if (!defined('HWDVIDSPATH')) { define('HWDVIDSPATH', dirname(__FILE__).'/../../'); }
		$c = hwd_vs_Config::get_instance();

		if (!isset($width)) {
			$width = $c->thumbwidth;
			$height = $width*3/4;
		}
			if (!isset($thumbwidth)) { $thumbwidth = $c->thumbwidth;}
			if (@explode(",", $option)) {
				$data = explode(",", $option);
				$thumbnail = $data[1];
			} else { $thumbnail = "ERROR"; }
			if (!$thumbnail) {
				$code = "<img src=\"".JURI::root( true )."/components/com_hwdvideoshare/images/default_thumb.jpg\" alt=\""._HWDVIDS_DETAILS_VIEWVID."\" border=\"0\" width=\"".$width."\" height=\"".$height."\" class=\"".$class."\" />";
			} else {
				if ($c->usegetheaders == 1) {
					if (function_exists('get_headers')) {
						if (@get_headers($thumbnail)) {
							$code = "<img src=\"".$thumbnail."\" border=\"0\" width=\"".$width."\" class=\"".$class."\" />";
						} else {
							$code = "<img src=\"".JURI::root( true )."/components/com_hwdvideoshare/images/default_thumb.jpg\" alt=\""._HWDVIDS_DETAILS_VIEWVID."\" border=\"0\" width=\"".$width."\" height=\"".$height."\" class=\"".$class."\" />";
						}
					}
				} else {
					$code = "<img src=\"".$thumbnail."\" border=\"0\" width=\"".$width."\" height=\"".$height."\" class=\"".$class."\" />";
				}
			}
			return $code;
	}
    /**
     * Prepares the third party video link
     *
     * @param string $option  the $video_id output containing video paramters
     * @param int    $vid  the video database id
     * @param int    $Itemid  the joomla menu id
     * @return       $code   the full third party thumbnail image tag
     */
	function youtubeComPrepareVideoURL($option)
	{
			if (@explode(",", $option)) {
				$data = explode(",", $option);
				$videocode = $data[0];
			} else { $videocode = "ERROR"; }

			$code = "http://www.youtube.com/watch?v=".$videocode;
			return $code;
	}
    /**
     * Prepares the third party video embed code
     *
     * @param string $option  the $video_id output containing video paramters
     * @param int    $vid  the video database id
     * @param int    $Itemid  the joomla menu id
     * @return       $code   the full third party thumbnail image tag
     */
	function youtubeComPrepareVideoEmbed($option, $vid, $Itemid)
	{
		global $mosConfig_sitename, $mosConfig_live_site;
		$c = hwd_vs_Config::get_instance();
			if (@explode(",", $option)) {
				$data = explode(",", $option);
				$videocode = $data[0];
			} else { $videocode = "ERROR"; }

			$code = null;
			if ($c->embedreturnlink == 1) {
				$code.='<div><center>';
			}
			$code.= "<object width=&#34;425&#34; height=&#34;355&#34;><param name=&#34;movie&#34; value=&#34;http://www.youtube.com/v/".$videocode."&rel=1&#34;></param><param name=&#34;wmode&#34; value=&#34;transparent&#34;></param><embed src=&#34;http://www.youtube.com/v/".$videocode."&rel=1&#34; type=&#34;application/x-shockwave-flash&#34; wmode=&#34;transparent&#34; width=&#34;425&#34; height=&#34;355&#34;></embed></object>";
			if ($c->embedreturnlink == 1) {
				$code.='<br /><a href=&#34;'.$mosConfig_live_site.'&#34; title=&#34;'.$mosConfig_sitename.'&#34;>'.$mosConfig_sitename.'</a></center></div>';
			}

			return $code;
	}
    /**
     * Prepares the third party video embed code
     *
     * @param string $option  the $video_id output containing video paramters
     * @param int    $vid  the video database id
     * @param int    $Itemid  the joomla menu id
     * @return       $code   the full third party thumbnail image tag
     */
	function youtubeComPrepareFlvURL($option)
	{
		global $mosConfig_sitename, $mosConfig_live_site;
		$c = hwd_vs_Config::get_instance();
			if (@explode(",", $option)) {
				$data = explode(",", $option);
				$videocode = $data[0];
			} else { $videocode = "ERROR"; }
			$code=null;

			$tube = new PHPTube ();
			$truepath = $tube->download($data[0]) ;

			if (isset($truepath) && !empty($truepath)) {
				$truepath = hwd_vs_tools::get_final_url( $truepath );
				$truepath = urlencode( $truepath );
			}

			return $truepath;
	}

require_once 'Request.php';

/**
 * @package    hwdVideoShare
 * @author     Dave Horsfall <info@highwooddesign.co.uk>
 * @copyright  2008 Highwood Design
 * @license    http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @version    1.1.4 Alpha RC3.5
 */
 if (!class_exists('PHPTube')) {
	class PHPTube {

		var $cookies;
		var $mgr;
		var $req;
		var $debug = true;
		var $auth = false;

		// Function:	PHPTube   ... Initialize PHPTube-Object
		// Paramters:	$username ... YouTube Accountname (if empty, upload is disabled)
		//						$password ... YouTube Passwort (if empty, upload is disabled)
		//						$debug	  ... Debug-Flag

		function PHPTube () {


		}

		// Function:	download  ... Download any Video-Clip from YouTube
		// Paramters:	$video_id ... Video-ID as given in YouTube URL (f.e. the Video at http://youtube.com/watch?v=TWZ5j-SNVKs
		//							  has the ID "TWZ5j-SNVKs"
		//				$video_filename ... local path+filename, the video is downloaded to (check write-permissions!)

		function download ($video_id) {
			$url = "http://www.youtube.com/watch?v=".$video_id;
			$url = hwd_vs_tools::get_final_url( $url );

			$this->req =& new HTTP_Request($url);
			$response = $this->req->sendRequest();
			if (hwdPEAR::isError($response)) {
				echo $response->getMessage()."\n";
			} else {
				$page = $this->req->getResponseBody();
				//preg_match('/watch_fullscreen\?video_id=(.*?)&l=(.*?)+&t=(.*?)&/', $page, $match);
				preg_match('/"video_id": "(.*?)"/', $page, $match);
				$var_id = @$match[1];

				preg_match('/"t": "(.*?)"/', $page, $match);
				$var_t = @$match[1];

				$url = "";
				$url .= $var_id;
				$url .= "&t=";
				$url .= $var_t;
				$url = "http://www.youtube.com/get_video?video_id=".$url;
				if ($this->debug)
					return $url;


			}


		}


	}
}
?>