<?php
/**
 * @version 2.0.1
 * @package moseasymedia
 * @copyright Copyright &copy; 2008, Brilaps LLC
 * @author Ozgur Cem Sen
 * @email code@brilaps.com
 * @link http://brilaps.com || http://wiki.brilaps.com
 * @license http://www.opensource.org/licenses/gpl-license.php GNU/GPL v.2 .
 */
require_once($MOSEASYMEDIA_ABSOLUTE_PATH."moseasymediaEmbed.php");

class cmoseasymediaJWMediaPlayer extends cmoseasymediaEmbed {
	/**
	 * Function for embedding the audio files associated with JWMediaPlayer
	 * @return string formatted HTML embed string
	 *
	 * http://www.jeroenwijering.com/extras/readme.html
	 */
	function moseasymediaJWMediaPlayer() {
		 
		global $MOSEASYMEDIA_BASE_URL;	
		$embedString = "";
		$player_swf = 'players/mediaplayer.swf';
		//the following arrays will serve as attributes to be populated by the $this->moseasymediaparams
		$object_attributes = array('id', 'classid', 'codebase', 'standby', 'type', 'width', 'height');
		$object_attribute_values = moseasymediaPlayerEngine::generateAttributeValuesArray($this->player, $object_attributes, $this->moseasymediaparams, TRUE);
		//additional..
		$object_attribute_values['id'] = $this->uniqueID;
		 
		 
		$param_attributes = array('src', 'width', 'height', 'wmode', 'allowscriptaccess');
		$param_attribute_values = moseasymediaPlayerEngine::generateAttributeValuesArray($this->player, $param_attributes, $this->moseasymediaparams, TRUE);
		$param_attribute_values['src'] = $MOSEASYMEDIA_BASE_URL.$player_swf;
	
		 
		// $flashvars_attributes = array('width', 'height', 'logo', 'overstretch', 'shownavigation', 'autostart', 'volume', 'repeat', 'backcolor', 'frontcolor', 'lightcolor');
		$flashvars_attributes = array('width', 'height', 'displayheight', 'logo', 'overstretch', 'shownavigation', 'autostart', 'volume', 'repeat', 'backcolor', 'frontcolor', 'lightcolor', 'largecontrols', 'image', 'title', 'link', 'wmode', 'shuffle');
		$flashvars_attribute_values = moseasymediaPlayerEngine::generateAttributeValuesArray($this->player, $flashvars_attributes, $this->moseasymediaparams, TRUE);
		$flashvars_attribute_values['file'] = $this->mediaPath;
		$strflashvars = "";
		foreach ($flashvars_attribute_values as $k=>$v) {
			if (strlen(trim($v))> 0)
			$strflashvars .= '&'.$k.'='.$v;
		}
		$embed_atrributes = array('name', 'id', 'src', 'width', 'height', 'type', 'pluginspage', 'wmode', 'allowscriptaccess');
		$embed_attribute_values = moseasymediaPlayerEngine::generateAttributeValuesArray($this->player, $embed_atrributes, $this->moseasymediaparams, TRUE);
		//additional..
		$embed_attribute_values['src'] = $MOSEASYMEDIA_BASE_URL.$player_swf;
		$embed_attribute_values['name'] = $this->uniqueID;
		$embed_attribute_values['id'] = $this->uniqueID;
		 
		//trick here
		$embed_attribute_values['flashvars'] = $strflashvars;
		$object_attribute_values['flashvars'] = $strflashvars;
		 
	
		//Check to see if we're using object embedding with flashvars or swobjects.js
		if ($this->moseasymediaparams->get("ocsmem_Useflashvars$this->player") == "flashvars") {
			//embed as usual - flashvars are already in the embed section
			$embedString .=moseasymediaPlayerEngine::generateObjectParamEmbedCode($object_attribute_values, $param_attribute_values, $embed_attribute_values);
			$embedString .= '</div>';
			$embedString .= '<!-- moseasymedia -->' ;
		}
		else {
			//here comes the SWFObject
			$embedString .= '&nbsp;</div>';
			$embedString .= '<!-- moseasymedia -->' ;
			$embedString .= '<script src="'.$MOSEASYMEDIA_BASE_URL.'js/swfobject.js" type="text/javascript"></script>';			                 
			$embedString .= '<script type="text/javascript">';
			$embedString .= '   var so = new SWFObject("'.$embed_attribute_values['src'].'","'.$this->uniqueID.'","'.$flashvars_attribute_values['width'].'","'.$flashvars_attribute_values['height'].'","7");';
			$embedString .= '   so.addParam("allowfullscreen","true");';
			$embedString .= '   so.addParam("shuffle","'.$flashvars_attribute_values['shuffle'].'");';
			$embedString .= '   so.addParam("wmode","'.$flashvars_attribute_values['wmode'].'");';
			$embedString .= '   so.addParam("allowscriptaccess","'.$embed_attribute_values['allowscriptaccess'].'");';
			foreach ($flashvars_attribute_values as $k=>$v) {
				if (strlen(trim($v))> 0)
				$embedString .= '   so.addVariable("'.$k.'","'.$v.'");';
			}
			$embedString .= '   so.write("'.$this->div_id.'");';
			$embedString .= '</script>';
		}

		if ($this->moseasymediaparams->get("ocsmem_Popup_popup", "none") === "none") {
			$embedString = $this->getHeader().$embedString.$this->getFooter();
		}
		else {	
			if (($this->moseasymediaparams->get("ocsmem_Popup_popup", "none") === "window") &&  
					($this->moseasymediaparams->get("ocsmem_Popup_popupmediathumbnail", "none") === "none"))
				$embedString = $this->getHeader().$embedString.$this->popupCode($embedString.$this->getFooter()).$this->getFooter();
			else 
				$embedString = $this->getHeader().$this->popupCode($embedString.$this->getFooter()).$this->getFooter();
		}
				
		return $embedString;
	}
}
?>