<?php
/**
 * @version 2.0.1
 * @package moseasymedia
 * @copyright Copyright &copy; 2008, Brilaps LLC
 * @author Ozgur Cem Sen
 * @email code@brilaps.com
 * @link http://brilaps.com || http://wiki.brilaps.com
 * @license http://www.opensource.org/licenses/gpl-license.php GNU/GPL v.2 .
 */
require_once($MOSEASYMEDIA_ABSOLUTE_PATH."moseasymediaEmbed.php");

class cmoseasymediaQuicktime extends cmoseasymediaEmbed {
	/**
	 * Function for embedding the audio files associated with Quicktime
	 * @return string formatted HTML embed string
	 *
	 * http://www.apple.com/quicktime/tutorials/embed.html
	 */
	function moseasymediaQuicktime () {
		 
		global $MOSEASYMEDIA_BASE_URL;	
		$embedString = "";	
		//the following arrays will serve as attributes to be populated by the $this->moseasymediaparams
		$object_attributes = array('id', 'classid', 'codebase', 'standby', 'type', 'width', 'height');
		$object_attribute_values = moseasymediaPlayerEngine::generateAttributeValuesArray($this->player, $object_attributes, $this->moseasymediaparams, TRUE);
		//additional..
		$object_attribute_values['id'] = $this->uniqueID;
		 
		 
		$param_attributes = array('url', 'src', 'filename', 'movie', 'width', 'height', 'autoplay', 'controller', 'loop');
		$param_attribute_values = moseasymediaPlayerEngine::generateAttributeValuesArray($this->player, $param_attributes, $this->moseasymediaparams, TRUE);
		//additional..
		$param_attribute_values['url'] = $this->mediaPath;
		$param_attribute_values['src'] = $this->mediaPath;
		$param_attribute_values['filename'] = $this->mediaPath;
		$param_attribute_values['movie'] = $this->mediaPath;
	
		$embed_atrributes = array('name', 'id', 'url', 'src', 'movie', 'filename', 'width', 'height', 'type', 'pluginspage', 'autoplay', 'controller', 'loop', 'pluginspage');
		$embed_attribute_values = moseasymediaPlayerEngine::generateAttributeValuesArray($this->player, $embed_atrributes, $this->moseasymediaparams, TRUE);
		//additional..
		$embed_attribute_values['url'] = $this->mediaPath;
		$embed_attribute_values['src'] = $this->mediaPath;
		$embed_attribute_values['filename'] = $this->mediaPath;
		$embed_attribute_values['movie'] = $this->mediaPath;
		$embed_attribute_values['name'] = $this->uniqueID;
		$embed_attribute_values['id'] = $this->uniqueID;
	
		 
		//THE KEY TO EVERYTHING IN moseasymedia
		$strMediaEmbedCode = moseasymediaPlayerEngine::generateObjectParamEmbedCode($object_attribute_values, $param_attribute_values, $embed_attribute_values);
	
		//Check to see if we're using object embedding or javascript
		if ((int)$this->moseasymediaparams->get("ocsmem_UseJavascript$this->player") == 0) {
			$embedString .= $strMediaEmbedCode;
		}
		else {
            $embedString = '<script src="'.$MOSEASYMEDIA_BASE_URL.'js/dreadedActiveX.js" type="text/javascript"></script>';                          			
			$escapedEmbed = cmoseasymediaEmbed::getEscaped($strMediaEmbedCode);
			$embedString .= '<script type="text/javascript">';
			$embedString .= '   embedObject("'.$escapedEmbed.'");';
			$embedString .= '</script>';
		}
		
		if ($this->moseasymediaparams->get("ocsmem_Popup_popup", "none") === "none") {
			$embedString = $this->getHeader().$embedString.$this->getFooter();
		}
		else {	
			if (($this->moseasymediaparams->get("ocsmem_Popup_popup", "none") === "window") &&  
					($this->moseasymediaparams->get("ocsmem_Popup_popupmediathumbnail", "none") === "none"))
				$embedString = $this->getHeader().$embedString.$this->popupCode($embedString.$this->getFooter()).$this->getFooter();
			else 
				$embedString = $this->getHeader().$this->popupCode($embedString.$this->getFooter()).$this->getFooter();
		}
			
		return $embedString;
	}
}
?>
